#ifndef COMPARE_H
#define COMPARE_H

#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>

#define NNODES 10000000 //max number of nodes: will increase if needed
#define NCOMS 10000000 //max number of communities: will increase if needed
#define SCOM 10000000 //max size of community: will increase if needed
#define NCPN 10 //max number of community per nodes: will increase if needed

typedef struct {
	unsigned s;//size of the community
	unsigned smax;//maximum size of the community
	unsigned *nodes;//nodes in the community
} community;

typedef struct {
	unsigned n;//number of nodes
	unsigned m;//max number of nodes

	unsigned **c;//c[i]=communities containing node i.
	unsigned *s;//s[i]=number of communities containing node i.
	unsigned *smax;//smax[i]=max number of communities

	unsigned nc;//number of communities
	unsigned mc;//max number of communities
	unsigned *size;//size[i]=size of the community i

	unsigned *tmp;//tmp[i] number of nodes shared by the current community and community i
	unsigned *list;//list of the community sharing at least one node with the current community
	unsigned nlist;//length of list
} compare;

//allocating memory for the community datastructure
community *alloccom();

//allocating memory for the cleaning datastructure
compare *alloccompare();

//reading one line = one community
bool readlinecom(FILE*,community*);

//add the community to the compare datastructure
void com2comp(community*,compare*);

//compute the similarity (F-score) of the current community to the most similar community in compare
double comsim(community*,compare*);

#endif
